int SCALAR_VAL(double);
int SQRT_FUN(int);

void foo(int _PB_N, int _PB_M, int** data, int* mean, int* stddev, int float_n, int eps, int** corr)
{
#pragma scop
	for (int j = 0; j < _PB_M; j++)
	{
		for (int i = 0; i <= _PB_N; i++){
			if(i==0)
				mean[j] = SCALAR_VAL(0.0);
			if(i>=0 && i < _PB_N)
				mean[j] += data[i][j];
			if(i==_PB_M)
				mean[j] /= float_n;
		}
	}
	for (int j = 0; j < _PB_M; j++)
	{
		for (int i = 0; i <= _PB_N; i++){
			if(i==0)
				stddev[j] = SCALAR_VAL(0.0);
			if(i>=0 && i < _PB_N)
				stddev[j] += (data[i][j] - mean[j]) * (data[i][j] - mean[j]);
			if(i==_PB_M){
				stddev[j] /= float_n;
				stddev[j] = SQRT_FUN(stddev[j]);
				stddev[j] = stddev[j] <= eps ? SCALAR_VAL(1.0) : stddev[j];
			}
		}
	}
	/* Center and reduce the column vectors. */
	for (int i = 0; i < _PB_N; i++)
		for (int j = 0; j < _PB_M; j++)
		{
			data[i][j] -= mean[j];
			data[i][j] /= SQRT_FUN(float_n) * stddev[j];
		}
	/* Calculate the m * m correlation matrix. */

	for (int i = 0; i < _PB_M-1; i++)
		{
			for (int j = i + 1; j < _PB_M; j++)
			{
				for (int k = 0; k <= _PB_N; k++){
					if(j == i + 1 && k==0)
						corr[i][i] = SCALAR_VAL(1.0);
					if(j >= i + 1){
						if( k==0)
							corr[i][j] = SCALAR_VAL(0.0);
						if( k>=0 && k < _PB_N)
							corr[i][j] += (data[k][i] * data[k][j]);
						if( k==_PB_M)
							corr[j][i] = corr[i][j];
					}
				}
			}
		}

	corr[_PB_M-1][_PB_M-1] = SCALAR_VAL(1.0);
#pragma endscop
}
