/*
 * calc_scope.h
 *
 *  Created on: 5 cze 2018
 *      Author: Maciej
 */

#ifndef CALC_SCOP_H_
#define CALC_SCOP_H_

#include <pet.h>
#include <isl/ctx.h>
#include <isl/union_set.h>
#include <isl/union_map.h>
#include <isl/map.h>
#include <isl/schedule.h>


#if defined(__cplusplus)
extern "C" {
#endif

typedef struct calc_scop{
	isl_ctx *ctx;

	int scopeDimSize;
	int dimCount;
	char (*idNames)[8];

	isl_union_set* orig_domain;
	isl_union_set* domain;
	isl_schedule* schedule;
	isl_union_map* may_reads;
	isl_union_map* may_writes;
	isl_union_map* must_writes;

	isl_union_map* schedule_map;
	isl_union_map* schedule_mapper;
	isl_union_map* before;
	isl_union_map* dep_raw;
	isl_union_map* dep_war;
	isl_union_map* dep_waw;
	isl_union_map* relations;
	isl_union_set* delta;

	isl_schedule* islSchedule;
	isl_union_map* islScheduleMap;

	isl_schedule* islScheduleNoTuples;
	isl_union_map* islScheduleMapNoTuples;

} calc_scop;

typedef struct calc_scop_list{
	int counter;
	calc_scop **calc_scop_list;

	int dimCount;
	char (*idNames)[8];
} calc_scop_list;

__isl_give calc_scop *calc_scop_from_pet_scop(isl_ctx *ctx, __isl_keep pet_scop *pet);

calc_scop_list* calc_scop_normalize(__isl_keep calc_scop *oryginal, isl_bool islScheduleOptimize);
__isl_null calc_scop_list *calc_scop_list_free(__isl_take calc_scop_list *list);

__isl_give calc_scop *calc_scop_alloc(isl_ctx *ctx);
__isl_null calc_scop *calc_scop_free(__isl_take calc_scop *calc);


#if defined(__cplusplus)
}
#endif

#endif /* CALC_SCOP_H_ */
