/*
 * debug_tool.h
 *
 *  Created on: 18 cze 2019
 *      Author: Maciej
 */

#ifndef DEBUG_TOOL_H_
#define DEBUG_TOOL_H_

#include <isl/union_map.h>
#include <isl/union_set.h>
#include <isl/map.h>
#include <isl/set.h>
#include <isl/schedule.h>

void isl_debug_on();
int isl_debug_is_on();

int isl_debug_printf(const char* template, const char* str);
int isl_debug_printf_str(const char* template, __isl_take char* isl_str);

int isl_debug_printf_union_set(const char* template, __isl_keep isl_union_set* uset);
int isl_debug_printf_union_map(const char* template, __isl_keep isl_union_map* umap);

int isl_debug_printf_set(const char* template, __isl_keep isl_set* set);
int isl_debug_printf_map(const char* template, __isl_keep isl_map* map);

int isl_debug_printf_schedule(const char* template, __isl_keep isl_schedule* sched);

#endif /* DEBUG_TOOL_H_ */
