/*
 * isl_tool.h
 *
 *  Created on: 5 cze 2019
 *      Author: Maciej
 */

#ifndef ISL_TOOL_H_
#define ISL_TOOL_H_

#include <isl/map.h>
#include <isl/union_map.h>
#include <isl/set.h>
#include <isl/union_set.h>
#include <isl/schedule.h>

isl_stat isl_union_map_foreach_map_in_map(__isl_keep isl_union_map *umap,
	isl_stat (*fn)(__isl_take isl_map *map, void *user), void *user);
isl_stat isl_union_set_foreach_set_in_set(__isl_keep isl_union_set *uset,
	isl_stat (*fn)(__isl_take isl_set *set, void *user), void *user);

int isl_printf_str(const char* template, __isl_take char* isl_str);
int isl_printf_union_set(const char* template, __isl_keep isl_union_set* uset);
int isl_printf_union_map(const char* template, __isl_keep isl_union_map* umap);
int isl_printf_schedule(const char* template, __isl_keep isl_schedule* sched);

isl_set* isl_set_renew(__isl_take isl_set* set);
isl_map* isl_map_renew(__isl_take isl_map* map);

char* get_pw_aff_value_to_str(isl_pw_aff* pw_aff);
int get_pw_aff_value_to_int(__isl_take isl_pw_aff* pw_aff);

isl_stat clear_tuple_names_in_map(__isl_take isl_map *map, void *user);
isl_stat clear_tuple_name_in_set(__isl_take isl_set *set, void *user);

#endif /* ISL_TOOL_H_ */
